﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Xml.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace slMap
{

  public class clsItems
  {
    public clsItems(String strInit)
    {
      Text = strInit;
    }
    
    private String Text;
    public String text
    {
      get
      {
        return Text;
      }
      set
      {
        Text = value;
      }
    }
  }

  public partial class ItemSelectan : UserControl
  {
    private String strDefText = "未選択";
    private double dblDefListHeight = 120;
    private String strDefXMLKey = "";
    private String strXMLName = "data.xml";
    
    private static double SELECTAN_WIDTH_OFFSET = 20;
    
    // 自作イベント
    public event RoutedEventHandler OnChange;

    // ぷろぱてー定義
    public String Text
    {
      get
      {
        if (true)
        {
          return txtView.Text;
        }
        else
        {
          //return strDefText;
        }
      }
      set
      {
        txtView.Text = value;
      }
    }

    public String strDef
    {
      get
      {
        return strDefText;
      }
      set
      {
        strDefText = value;
        txtView.Text = value;
      }
    }

    public Brush BackGround
    {
      get
      {
        return bdrBase.Background;
      }
      set
      {
        bdrBase.Background = value;
      }
    }

    public double width
    {
      get
      {
        return this.Width;
      }
      set
      {
        this.Width = value;
        stkPanel.Width = value + SELECTAN_WIDTH_OFFSET;
        bdrBase.Width = value;
        txtView.Width = value;
        lstSelect.Width = value + SELECTAN_WIDTH_OFFSET;
      }
    }

    public double height
    {
      get
      {
        return bdrBase.Height;
      }
      set
      {
        //this.Height = value;
        bdrBase.Height = value;
        //txtView.Height = value;
      }
    }

    public double lstHeight
    {
      get
      {
        return lstSelect.Height;
      }
      set
      {
        lstSelect.Height = value;
      }
    }
    
    public String XMLKey
    {
      get
      {
        return strDefXMLKey;
      }
      set
      {
        strDefXMLKey = value;
        if(value.Length == 0)
        {
          lstSelect.Items.Clear();
        }
        else
        {
          SetSelectItems(strXMLName);
        }
      }
    }
    
    // 初期化
    public ItemSelectan()
    {
      InitializeComponent();
      txtView.Text = strDefText;
      lstSelect.Height = dblDefListHeight;
    }

    // せれくたん、初期化
    public void ClearSelectItems()
    {
      lstSelect.ItemsSource = null;
      Text = strDefText;
    }
    public void SetSelectItems(String strXMLFileName)
    {
      SetSelectItems(strXMLFileName, strDefXMLKey);
    }

    // せれくたん、初期化
    public void SetSelectItems(String strXMLFileName, String strXMLKey)
    {
      XElement xmlRoot = XElement.Load(strXMLFileName);
      IEnumerable<XElement> query =
      from xmlData in xmlRoot.Elements(strXMLKey) select xmlData;

      List<clsItems> ItemList = new List<clsItems>();
      foreach (XElement res in query)
      {
        ItemList.Add(new clsItems(res.Attribute("value").Value));
      }
      lstSelect.ItemsSource = ItemList;
      Text = strDefText;
    }

    // せれくたん、未使用項目指定で初期化
    public void SetSelectItems(String[] strIgnores)
    {
      SetSelectItems(strXMLName, strDefXMLKey, strIgnores);
    }

    // せれくたん、未使用項目指定で初期化
    public void SetSelectItems(String[] strIgnores, String strXMLKey)
    {
      SetSelectItems(strXMLName, strXMLKey, strIgnores);
    }

    // せれくたん、未使用項目指定で初期化
    public void SetSelectItems(String strXMLFileName, String[] strIgnores)
    {
      SetSelectItems(strXMLFileName, strDefXMLKey, strIgnores);
    }
    //strDefXMLKey
    // せれくたん、未使用項目指定で初期化
    public void SetSelectItems(String strXMLFileName, String strXMLKey, String[] strIgnores)
    {
      Text = strDefText;

      XElement xmlRoot = XElement.Load(strXMLFileName);
      IEnumerable<XElement> query =
      from xmlData in xmlRoot.Elements(strXMLKey) where !strIgnores.Contains(xmlData.Attribute("value").Value) select xmlData;

      List<clsItems> ItemList = new List<clsItems>();
      foreach (XElement res in query)
      {
        ItemList.Add(new clsItems(res.Attribute("value").Value));
      }
      lstSelect.ItemsSource = ItemList;
      Text = strDefText;
    }

    // イベント定義
    // マウスが外れたのでせれくたん非表示
    private void OnMouseLeave(object sender, MouseEventArgs e)
    {
      lstSelect.Visibility = Visibility.Collapsed;
    }

    // マウスが入ってきたのでせれくたんを表示
    private void OnMouseEnter(object sender, MouseEventArgs e)
    {
      lstSelect.Visibility = Visibility.Visible;
    }

    // せれくたんの選択変更処理：表示部分を書き換えるの
    private void OnSelectionChanged(object sender, SelectionChangedEventArgs e)
    {
      if(lstSelect.SelectedIndex < 0)
      {
        txtView.Text = strDefText;
      }
      else
      {
        txtView.Text = ((clsItems)lstSelect.SelectedItem).text;
        lstSelect.Visibility = Visibility.Collapsed;

        // OnChangeイベント発生
        OnChange(this, new RoutedEventArgs());
      }
      
    }
  }
}
